﻿@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
    Layout = "~/Views/Shared/_faasoftwarelayout.cshtml";
}

<div class="container">
    <div class="row">
        <div class=" col-sm-12 pull-right">
            <!-- Basic Modal -->
            <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#myModal">
                New Unit Type
            </button>
        </div>
    </div>

    <div class="modal fade" id="myModal" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="lblTitle">New Unit Type</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <input type="hidden" id="hdUnt_Id" />
                    <div class="row">
                        <div class="col-sm-12">
                            <label for="">Unit Name</label>
                            <input type="text" id="txtUnt_Name" class="form-control" placeholder="Enter Unit Type" />
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                    <button type="button" id="btnSave" class="btn btn-primary" onclick="SaveUnit()">Save</button>
                </div>
            </div>
        </div>
    </div>


    <div class="row">
        <table id="tblUnit" class="table table-bordered table-striped">
            <tr>
                <th>S No</th>
                <th>Unit Name</th>
                <th>Action</th>
            </tr>
        </table>
    </div>
</div>

<script src="https://code.jquery.com/jquery-3.7.0.js"></script>
<script>

    $(document).ready(function () {
        BindTable();
    });

    function BindTable() {
        $.ajax({
            url: "/Unit/GetAllUnit",
            method: 'get',
            success: Onsuccess
        });
    }

    function Onsuccess(response) {
        console.log(response);
        $('#tblUnit').DataTable({
            bProcessing: true,
            bLenghtChange: true,
            retrieve: true,
            bfilter: true,
            bSort: true,
            bPaging: true,
            data: response,
            columns: [
                { data: 'untId', name: 'S no' },

                {
                    data: "untName", name: 'Unit Name',
                    render: function (data, type, row, meta) {
                        return row.untName
                    }
                },
                {
                    data: "untId", name: 'Action',
                    render: function (data, type, row, meta) {
                        return '<button type="button" class="btn btn-primary" onclick = UpdateShow(' + row.untId + ') > Update </button> &nbsp;<button type="button" class="btn btn-danger" onclick="DeleteConfirmation(' + row.untId + ')">Delete</button>';
                    }
                },
            ]
        });
    }

    function SaveUnit() {
        var returnValue = true;
        if ($("#txtUnt_Name").val() == "") {
            $("#txtUnt_Name").focus();
            Message("error", "Unit Name is required");
            returnValue = false;
        }
        else {
            var obj = {
                UntId: $("#hdUnt_Id").val(),
                UntName: $("#txtUnt_Name").val(),
            }
            $.ajax({
                method: "POST",
                url: '@Url.Action("SaveUnit", "Unit")',
                data: obj,
                crossDomain: true,
                success: function (result) {
                    if (result > 0) {
                        if ($("#hdUnt_Id").val() > 0) {
                            Message("success", "Updated Data Successfully");

                        }
                        else {
                            Message("success", "Saved Data Successfully");
                        }
                        $("#hdUnt_Id").val('');
                        $("#txtUnt_Name").val('');
                        $("#myModal").modal('hide');
                        $("#btnSave").html("Save");
                        $("#lblTitle").html("New Unit");
                        BindTable()
                    }
                    else {

                        Message("error", "Somthing went wrong");
                    }
                },
                error: function (e) {
                    Message("warning", "Somthing went wrong");

                }
            });
        }
    }

    function UpdateShow(Id) {
        $.ajax({
            method: "GET",
            url: '@Url.Action("GetByIdUnit", "Unit")',
            data: { Id: Id },
            crossDomain: true,
            success: function (result) {
                console.log(result);
                if (result != null) {
                    $("#hdUnt_Id").val(result[0].untId);
                    $("#txtUnt_Name").val(result[0].untName);
                    $("#btnSave").html("Update");
                    $("#lblTitle").html("Update Unit");

                    $("#myModal").modal('show');
                }
                else {

                    Message("error", "Somthing went wrong");
                }
            },
            error: function (e) {
                Message("warning", "Somthing went wrong");

            }
        });
    }


    function Delete() {
        var Id = $("#hdDeleteId").val();
        $("#modelDeleteConfirmation").modal('hide');
        $("#hdDeleteId").val('');

        if (Id > 0) {
            $.ajax({
                method: "GET",
                url: '@Url.Action("DeleteUnit", "Unit")',
                data: { Id: Id },
                crossDomain: true,
                success: function (result) {
                    if (result) {
                        Message("success", "Deleted Data Successfully");
                        BindTable();
                    }
                    else {

                        Message("error", "Somthing went wrong");
                    }
                },
                error: function (e) {
                    Message("warning", "Somthing went wrong");
                }
            });
        }
    }
    </script>